/*----- PROTECTED REGION ID(FastPSClass.h) ENABLED START -----*/
//=============================================================================
//
// file :        FastPSClass.h
//
// description : Include for the FastPS root class.
//               This class is the singleton class for
//                the FastPS device class.
//               It contains all properties and methods which the 
//               FastPS requires only once e.g. the commands.
//
// project :     CaenElsFastPS
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
//
// Elettra-Sincrotrone Trieste S.C.p.A. di interesse nazionale
// Strada Statale 14 - km 163,5 in AREA Science Park
// 34149 Basovizza, Trieste ITALY
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef FastPSClass_H
#define FastPSClass_H

#include <tango.h>
#include <FastPS.h>


/*----- PROTECTED REGION END -----*/	//	FastPSClass.h


namespace FastPS_ns
{
/*----- PROTECTED REGION ID(FastPSClass::classes for dynamic creation) ENABLED START -----*/


/*----- PROTECTED REGION END -----*/	//	FastPSClass::classes for dynamic creation

//=========================================
//	Define classes for attributes
//=========================================
//	Attribute CurrentControl class definition
class CurrentControlAttrib: public Tango::Attr
{
public:
	CurrentControlAttrib():Attr("CurrentControl",
			Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~CurrentControlAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<FastPS *>(dev))->read_CurrentControl(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<FastPS *>(dev))->write_CurrentControl(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<FastPS *>(dev))->is_CurrentControl_allowed(ty);}
};

//	Attribute VoltageControl class definition
class VoltageControlAttrib: public Tango::Attr
{
public:
	VoltageControlAttrib():Attr("VoltageControl",
			Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~VoltageControlAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<FastPS *>(dev))->read_VoltageControl(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<FastPS *>(dev))->write_VoltageControl(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<FastPS *>(dev))->is_VoltageControl_allowed(ty);}
};

//	Attribute Voltage class definition
class VoltageAttrib: public Tango::Attr
{
public:
	VoltageAttrib():Attr("Voltage",
			Tango::DEV_DOUBLE, Tango::READ) {};
	~VoltageAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<FastPS *>(dev))->read_Voltage(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<FastPS *>(dev))->is_Voltage_allowed(ty);}
};

//	Attribute Current class definition
class CurrentAttrib: public Tango::Attr
{
public:
	CurrentAttrib():Attr("Current",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~CurrentAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<FastPS *>(dev))->read_Current(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<FastPS *>(dev))->write_Current(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<FastPS *>(dev))->is_Current_allowed(ty);}
};

//	Attribute CurrentSet class definition
class CurrentSetAttrib: public Tango::Attr
{
public:
	CurrentSetAttrib():Attr("CurrentSet",
			Tango::DEV_DOUBLE, Tango::READ) {};
	~CurrentSetAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<FastPS *>(dev))->read_CurrentSet(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<FastPS *>(dev))->is_CurrentSet_allowed(ty);}
};

//	Attribute WaveformExternalTrigger class definition
class WaveformExternalTriggerAttrib: public Tango::Attr
{
public:
	WaveformExternalTriggerAttrib():Attr("WaveformExternalTrigger",
			Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~WaveformExternalTriggerAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<FastPS *>(dev))->read_WaveformExternalTrigger(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<FastPS *>(dev))->write_WaveformExternalTrigger(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<FastPS *>(dev))->is_WaveformExternalTrigger_allowed(ty);}
};

//	Attribute VoltageDCLink class definition
class VoltageDCLinkAttrib: public Tango::Attr
{
public:
	VoltageDCLinkAttrib():Attr("VoltageDCLink",
			Tango::DEV_DOUBLE, Tango::READ) {};
	~VoltageDCLinkAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<FastPS *>(dev))->read_VoltageDCLink(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<FastPS *>(dev))->is_VoltageDCLink_allowed(ty);}
};

//	Attribute MosfetTemperature class definition
class MosfetTemperatureAttrib: public Tango::Attr
{
public:
	MosfetTemperatureAttrib():Attr("MosfetTemperature",
			Tango::DEV_DOUBLE, Tango::READ) {};
	~MosfetTemperatureAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<FastPS *>(dev))->read_MosfetTemperature(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<FastPS *>(dev))->is_MosfetTemperature_allowed(ty);}
};

//	Attribute AnalogControl class definition
class AnalogControlAttrib: public Tango::Attr
{
public:
	AnalogControlAttrib():Attr("AnalogControl",
			Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~AnalogControlAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<FastPS *>(dev))->read_AnalogControl(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<FastPS *>(dev))->write_AnalogControl(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<FastPS *>(dev))->is_AnalogControl_allowed(ty);}
};

//	Attribute WaveformTimeScale class definition
class WaveformTimeScaleAttrib: public Tango::Attr
{
public:
	WaveformTimeScaleAttrib():Attr("WaveformTimeScale",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~WaveformTimeScaleAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<FastPS *>(dev))->read_WaveformTimeScale(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<FastPS *>(dev))->write_WaveformTimeScale(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<FastPS *>(dev))->is_WaveformTimeScale_allowed(ty);}
};

//	Attribute WaveformPeriods class definition
class WaveformPeriodsAttrib: public Tango::Attr
{
public:
	WaveformPeriodsAttrib():Attr("WaveformPeriods",
			Tango::DEV_LONG, Tango::READ_WRITE) {};
	~WaveformPeriodsAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<FastPS *>(dev))->read_WaveformPeriods(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<FastPS *>(dev))->write_WaveformPeriods(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<FastPS *>(dev))->is_WaveformPeriods_allowed(ty);}
};

//	Attribute Waveform class definition
class WaveformAttrib: public Tango::SpectrumAttr
{
public:
	WaveformAttrib():SpectrumAttr("Waveform",
			Tango::DEV_DOUBLE, Tango::READ_WRITE, 500000) {};
	~WaveformAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<FastPS *>(dev))->read_Waveform(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<FastPS *>(dev))->write_Waveform(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<FastPS *>(dev))->is_Waveform_allowed(ty);}
};

//	Attribute HwWaveform class definition
class HwWaveformAttrib: public Tango::SpectrumAttr
{
public:
	HwWaveformAttrib():SpectrumAttr("HwWaveform",
			Tango::DEV_DOUBLE, Tango::READ_WRITE, 500000) {};
	~HwWaveformAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<FastPS *>(dev))->read_HwWaveform(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<FastPS *>(dev))->write_HwWaveform(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<FastPS *>(dev))->is_HwWaveform_allowed(ty);}
};


//=========================================
//	Define classes for commands
//=========================================
//	Command On class definition
class OnClass : public Tango::Command
{
public:
	OnClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	OnClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~OnClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<FastPS *>(dev))->is_On_allowed(any);}
};

//	Command Off class definition
class OffClass : public Tango::Command
{
public:
	OffClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	OffClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~OffClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<FastPS *>(dev))->is_Off_allowed(any);}
};

//	Command StartWaveform class definition
class StartWaveformClass : public Tango::Command
{
public:
	StartWaveformClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	StartWaveformClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~StartWaveformClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<FastPS *>(dev))->is_StartWaveform_allowed(any);}
};

//	Command Reset class definition
class ResetClass : public Tango::Command
{
public:
	ResetClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	ResetClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~ResetClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<FastPS *>(dev))->is_Reset_allowed(any);}
};

//	Command HwReset class definition
class HwResetClass : public Tango::Command
{
public:
	HwResetClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	HwResetClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~HwResetClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<FastPS *>(dev))->is_HwReset_allowed(any);}
};

//	Command StopWaveform class definition
class StopWaveformClass : public Tango::Command
{
public:
	StopWaveformClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	StopWaveformClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~StopWaveformClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<FastPS *>(dev))->is_StopWaveform_allowed(any);}
};


/**
 *	The FastPSClass singleton definition
 */

#ifdef _TG_WINDOWS_
class __declspec(dllexport)  FastPSClass : public Tango::DeviceClass
#else
class FastPSClass : public Tango::DeviceClass
#endif
{
	/*----- PROTECTED REGION ID(FastPSClass::Additionnal DServer data members) ENABLED START -----*/
	
	
	/*----- PROTECTED REGION END -----*/	//	FastPSClass::Additionnal DServer data members

	public:
		//	write class properties data members
		Tango::DbData	cl_prop;
		Tango::DbData	cl_def_prop;
		Tango::DbData	dev_def_prop;
	
		//	Method prototypes
		static FastPSClass *init(const char *);
		static FastPSClass *instance();
		~FastPSClass();
		Tango::DbDatum	get_class_property(string &);
		Tango::DbDatum	get_default_device_property(string &);
		Tango::DbDatum	get_default_class_property(string &);
	
	protected:
		FastPSClass(string &);
		static FastPSClass *_instance;
		void command_factory();
		void attribute_factory(vector<Tango::Attr *> &);
		void pipe_factory();
		void write_class_property();
		void set_default_property();
		void get_class_property();
		string get_cvstag();
		string get_cvsroot();
	
	private:
		void device_factory(const Tango::DevVarStringArray *);
		void create_static_attribute_list(vector<Tango::Attr *> &);
		void erase_dynamic_attributes(const Tango::DevVarStringArray *,vector<Tango::Attr *> &);
		vector<string>	defaultAttList;
		Tango::Attr *get_attr_object_by_name(vector<Tango::Attr *> &att_list, string attname);
};

}	//	End of namespace

#endif   //	FastPS_H
